"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var nodeList = 'button, [href], input, textarea, select, [tabindex]:not([tabindex="-1"])';
var handler = function (e) {
    var _a, _b, _c, _d;
    if (!(e instanceof KeyboardEvent) || !e.target)
        return;
    var eventTarget = e.target;
    var blackList = ['select', 'textarea'];
    if (blackList.includes(eventTarget.tagName.toLowerCase()))
        return;
    var doFocus = function (target) {
        if (!target)
            return;
        target.focus();
    };
    switch (e.which) {
        case 39: {
            var doNavi = function () {
                var _a;
                e.preventDefault();
                var target = null;
                var nextSameTd = eventTarget.nextSibling;
                if (nextSameTd) {
                    target = nextSameTd;
                }
                else {
                    var nextTd = (_a = eventTarget.closest('td, .td')) === null || _a === void 0 ? void 0 : _a.nextSibling;
                    if (!nextTd)
                        return;
                    var list = nextTd.querySelectorAll(nodeList);
                    if (list.length) {
                        // eslint-disable-next-line prefer-destructuring
                        target = list[0];
                    }
                }
                if (target) {
                    doFocus(target);
                }
            };
            if (!(e.target instanceof HTMLInputElement)) {
                doNavi();
                break;
            }
            if (e.target.selectionStart === e.target.value.length) {
                doNavi();
            }
            break;
        }
        case 37: {
            var doNavi = function () {
                var _a;
                e.preventDefault();
                var target = null;
                var prevSameTd = eventTarget.previousSibling;
                if (prevSameTd) {
                    target = prevSameTd;
                }
                else {
                    var prevTd = (_a = eventTarget.closest('td, .td')) === null || _a === void 0 ? void 0 : _a.previousSibling;
                    if (!prevTd)
                        return;
                    var list = prevTd.querySelectorAll(nodeList);
                    if (list.length) {
                        target = list[list.length - 1];
                    }
                }
                if (target) {
                    doFocus(target);
                }
            };
            if (!(e.target instanceof HTMLInputElement)) {
                doNavi();
                break;
            }
            if (e.target.selectionStart === 0) {
                doNavi();
            }
            break;
        }
        case 40: {
            e.preventDefault();
            var next = (_a = eventTarget.closest('tr, .tr')) === null || _a === void 0 ? void 0 : _a.nextSibling;
            var original = eventTarget.closest('td, .td');
            var index = Array.prototype.slice.call((_b = original === null || original === void 0 ? void 0 : original.parentElement) === null || _b === void 0 ? void 0 : _b.children).indexOf(original);
            if (!index || !next)
                break;
            var nextTd = next.childNodes[index];
            if (!nextTd)
                break;
            var target = nextTd.querySelector(nodeList);
            doFocus(target);
            break;
        }
        case 38: {
            e.preventDefault();
            var prev = (_c = eventTarget.closest('tr')) === null || _c === void 0 ? void 0 : _c.previousSibling;
            var original = eventTarget.closest('td, .td');
            var index = Array.prototype.slice.call((_d = original === null || original === void 0 ? void 0 : original.parentElement) === null || _d === void 0 ? void 0 : _d.children).indexOf(original);
            if (!index || !prev)
                break;
            var prevTd = prev.childNodes[index];
            if (!prevTd)
                break;
            var target = prevTd.querySelector(nodeList);
            doFocus(target);
            break;
        }
        default:
            break;
    }
};
var formNavi = {
    bind: function (el) {
        el.addEventListener('keydown', handler);
    },
    unbind: function (el) {
        el.removeEventListener('keydown', handler);
    },
};
exports.default = formNavi;
//# sourceMappingURL=index.js.map